import java.net.*;
import java.io.*;
import java.util.*;

public class cSocket
{
  private LineNumberReader lnr;
  private Socket server;

  public cSocket (String addr, String port)
  {
    try
    {
      server = new Socket (addr, Integer.parseInt(port));
      lnr = new LineNumberReader(new BufferedReader(new InputStreamReader(server.getInputStream())));
    }
    catch (Exception e)
    {
      e.printStackTrace();
      System.out.println("It's Mo's fault (cSocket constructor): " + addr + " p:" + Integer.parseInt(port));
    }
  }

  public void sendLine (String s)
  {
    try
    {
      System.out.print ("Sending: "+s+"...");
      server.getOutputStream().write(s.getBytes());
      System.out.println ("sent!");
    }
    catch (Exception e)
    {
      System.out.println("Mo, you should only send when you are allowed to");
    }
  }
  
  public StringTokenizer getTokenizer()
  {
    try
    {
      return new StringTokenizer(getLine());
      //return new StreamTokenizer( new BufferedReader ( new InputStreamReader ( server.getInputStream())));
    }
    catch (Exception e)
    {
      System.out.println("It's Mo's fault");
    }
    return null;
  }

  public String getLine ()
  {
    try
    {
      System.out.print ("Reading...");
      String ret = lnr.readLine();
      System.out.println ("read: "+ret);
      return ret;
    }
    catch (Exception e)
    {
      System.out.println("Mo, you should only read when you are allowed to");
    }
    return "monkey";
  }
}
