import java.util.*;
import java.io.*;

// Added evaluator functions... 
// Added ALL packages as points of interest, even ones that we are carrying
// Mult[0] = Coeff for homeBase in hunting mode
// Mult[1] = Coeff for otherRobots in hunting mode
// Mult[2] = Coeff for Packags in hunting mode
// Mult[3] = Coeff for homeBase in carrying mode
// Mult[4] = Coeff for otherRobots in carrying mode
// Mult[5] = Coeff for Packags WE HAVE in carrying mode
// Mult[6] = Coeff for Packags WE DO NOT HAVE in carrying mode



class Motha {
  static float[] Mult;
  static int[] Coeffs;
  World world;
  ArrayList bases;
  ArrayList packages;
  ArrayList robots; 
  cSocket client;
  Robot monkeyJuicer;

  public Motha ()
  {
    robots = new ArrayList();
    packages = new ArrayList();
    bases = new ArrayList();
    world = null;
    client = null;
    Mult = new float[7];
    Coeffs = new int[14];
  }

  public ArrayList getMeSomePOT ()
  {
     ArrayList pot = new ArrayList();
     // AS AN OPTIMIZATION I'D SUGGEST ADDING ALL POTs TO A WORLD AT ONCE, THEN RUNNING
     // Floyd's algorithm (or whatever) TO GET ALL THE DISTANCES IN ONE SHOT
     World w = world.copyOf();
     System.out.println("XXXXX " + monkeyJuicer.getY() + " " + monkeyJuicer.getX());
     Bfs bfs = new Bfs(world, monkeyJuicer.getY(), monkeyJuicer.getX());
     /* I don't understand what all this cloning business is about.
      * Why are we using this? -Aly
      */
     //world.cloneWorld(w);
     
     // go through the entire world - only useful for water
     /* I think water should radiate a slight negative value around it
      * so we don't go wandering near it and get pushed in, inside the BFS
      * I will not even consider water as a potential move -Aly
      */
     
     /* I'm commenting this out, because I think water has to be special-cased - you don't want to start propagating
        values of -infinity all around you.
     for (int y=1; y <= world.rows; y++)
      for (int x=1; x <= world.cols; x++)
       if (world.board[y][x] == '~')
        pot.add(new POT(x, y, 0.0 // -infinity // ));
     */   
        
     // now process home bases
     for (int i=0; i < bases.size(); i++)
      if (!((homeBase) bases.get(i)).isVisited())  // if we've been here before, we have NO interest in this
      {
        homeBase h = ((homeBase) bases.get(i));
        /* I haven't read all your code, but aren't these things passed in the
         * original map anyways?  Why are we reassigning them to the map? -Aly
         */
        w.board[h.y][h.x] = '@';
        pot.add(h);
      }
      
     // now process robots 
     for (int i=0; i < robots.size(); i++)
      if ( ((Robot) robots.get(i)) != monkeyJuicer) // don't juice our own ass
      {
        Robot r = ((Robot) robots.get(i));
        /* Zaid and I thought we should leave the map alone as static info
         * if you feel otherwise please enlighten, otherwise please remove this
         * to make my coding easier -Aly
         */
        w.board[r.getY()][r.getX()] = 'r';
        pot.add(r);
      }
       
     // lastly, do packag`s
     for (int i=0; i < packages.size(); i++)
      {
        Packag p = ((Packag) packages.get(i));    // Removed "if"... Thus, add ALL packags!
        /* See comment in robot processing -Aly
         */
        w.board[p.y][p.x] = 'p';
        pot.add(p);
      }
      
     // run BFS on w
     // -- done in constructor

     // need to match items back to the ones above and use the distance we obtained appropriately
     for (int i=0; i < pot.size(); i++)
     {
       Functor a = ((Functor) pot.get(i));

       if (!a.known()) continue;

       if (a.getX() < 0 || a.getY() < 0) System.out.println("SCREW UP IN getMeSomePOT");

       a.distance = bfs.shortestDistanceTo(a.getY(), a.getX());    // WHATEVER, ok, this is bull-shit, but you get the idea
       // shouldn't need to fill in any other numbers...
       a.evaluate(monkeyJuicer.state, monkeyJuicer); // we now have a value for this POT!
       System.out.println("POT at " + a.getX() + "," + a.getY() + " = " + a.value());
     }
        
     // I think the calling function has to assign this to NULL when it's done to free memory - Zaid, Aly?   
     return pot;
  }

  public void addRobot (int id, int capacity, int x, int y, int money)
  {
    try
    {
       // let'd get down with this motha fucka
       for (int i=0; i < robots.size(); i++)
        if (((Robot) robots.get(i)).getID() == id)
          return;
       Robot temp = new Robot(id, capacity, x, y, money, Mult);
       robots.add(temp);
    }
    catch (Exception e)
    {
    }
  }

  public Packag addPackage (int id, int weight, int x, int y, int _x, int _y)
  {
    try
    {
      Packag temp = new Packag(id, weight, x, y, _x, _y, Mult);
      packages.add(temp);
      return temp;
    }
    catch (Exception e)
    {
      return null;
    }
  }

  public void parseBoardSize (String s)
  {
    System.out.println("parseBoardSize:" + s);
    int x = Integer.parseInt(s.substring(0,s.indexOf(' ')).trim());
    int y = Integer.parseInt(s.substring(s.indexOf(' ')).trim());
    world = new World(x, y);
  }

  public void parseNextRow (String row)
  {
    // do the home-bases 
  
    for (int i=0; i < row.length(); i++)
      if (row.charAt(i) == '@')
      {
        try
        {
           homeBase b = new homeBase(i+1, world.getRow(), Mult);
           bases.add(b);
        }
        catch (Exception e)
        {
        }
      }
  
    world.addRow(row);
  }

// MAY ADD FUNCTIONALITY TO UPDATE timesVisited FOR HOME BASES... USE moveRobot FUNCTION! -MA

  public void moveRobot (int id, char to)
  {

    Robot r = null;
    for (int i=0; i < robots.size(); i++)
      if ( ((Robot) robots.get(i)).getID() == id)
      {
        r = ((Robot) robots.get(i));
        break;
      }

    if (r != null)
    {
      /* Removed -1s since move now appears to only take in two ints -Aly
       */
      if (r == monkeyJuicer)
        for (int i=0; i < bases.size(); i++)
        {
          homeBase b = ((homeBase) bases.get(i));
          if (b.getX() == r.getX() && b.getY() == r.getY())
            b.visit();
        }
      if (to == 'E')
        r.move(r.getX()+1, r.getY());
      else if (to == 'W')
        r.move(r.getX()-1, r.getY());
      else if (to == 'N')
        r.move(r.getX(), r.getY()+1);
      else
        r.move(r.getX(), r.getY()-1);
      r.setAccessed(true);
    }
  }
  
  public void debugBoard()
  {
    world.printBoard();
  }
  
  public void initOurRobot()
  {
    StringTokenizer st = client.getTokenizer();
    try
    {
      int id = Integer.parseInt (st.nextToken()); 
      int capacity = Integer.parseInt (st.nextToken()); 
      int money = Integer.parseInt (st.nextToken()); 

      FileWriter out = new FileWriter(id+".ID");
      String score = new String("0");
      for (int i=0; i<14; i++)
      {
        score = score + " " + Coeffs[i];
      }
      out.write (score, 0, score.length());
      out.write (10);
      out.close ();

      monkeyJuicer = new Robot(id, capacity, -1, -1, money, Mult);
      monkeyJuicer.magic = 'X';
    
      robots.add(monkeyJuicer);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      System.out.println("P's fault in initOurRobot");
    }
  }
  
  public void __initOurRobot (String s)
  {
    int id = Integer.parseInt(s.substring(0,s.indexOf(' ')).trim());
    s = s.substring(s.indexOf(' ')).trim();
    int capacity = Integer.parseInt(s.substring(0,s.indexOf(' ')).trim());
    s = s.substring(s.indexOf(' ')).trim();
    int money = Integer.parseInt(s.trim());

    monkeyJuicer = new Robot(id, capacity, -1, -1, money, Mult);
    
    robots.add(monkeyJuicer);
  }

  public void placeRobots()
  {
    StringTokenizer st = client.getTokenizer();
    try
    {
      while (st.hasMoreElements())
      {

      int id = Integer.parseInt(st.nextToken().substring(1)); 
      st.nextToken(); /*X*/ 
      int x = Integer.parseInt(st.nextToken());
      st.nextToken(); /*Y*/ 
      int y = Integer.parseInt(st.nextToken());
     

      if (monkeyJuicer == null) { System.out.println("**** HUGE ERROR!!! ****"); return; }

      if (id == monkeyJuicer.getID())
        monkeyJuicer.move(x, y);
      else
        addRobot(id, -1, x, y, -1);
      }

    }
    catch (Exception e)
    {
      e.printStackTrace();
      System.out.println("P's fault in placeRobots");
    }
  }

  public void __placeRobots (String s)
  {
    s = s + " $";     // THIS TOOK FOREVER TO DEBUG!!! AAAAAH!
    // WHY THE HELL DON'T WE KNOW HOW TO PARSE PROPERLY?!
    while (true)
    {
      System.out.println(s);
      int id = Integer.parseInt(s.substring(1,s.indexOf(' ')).trim());
      s = s.substring(s.indexOf(' ')).trim();
      s = s.substring(s.indexOf(' ')).trim();
      int x = Integer.parseInt(s.substring(0,s.indexOf(' ')).trim());
      s = s.substring(s.indexOf(' ')).trim();
      s = s.substring(s.indexOf(' ')).trim();
      int y = Integer.parseInt(s.substring(0,s.indexOf(' ')).trim());
      if (monkeyJuicer == null) { System.out.println("**** HUGE ERROR!!! ****"); return; }
      if (id == monkeyJuicer.getID())
        monkeyJuicer.move(x, y);
      else
        addRobot(id, -1, x, y, -1);
      if (s.length() <= 3) break;     // Doesn't really matter...
      s = s.substring(s.indexOf(' ')).trim();
    }
  }

  public void debugRobots()
  {
    for (int i = 0; i < robots.size(); i++)
      System.out.print(((Robot) robots.get(i)).id + " ");
    System.out.println("");
  }

  /************  during-the-game-functions *********/

  public void updatePackages () throws Exception   // .. at current position ..
  {
    StringTokenizer st = client.getTokenizer();
    try
    {
      while ( st.hasMoreElements() )
      {
        int id = Integer.parseInt(st.nextToken());
        int x = Integer.parseInt(st.nextToken());
        int y = Integer.parseInt(st.nextToken());
        int w = Integer.parseInt(st.nextToken());

        boolean crap = false;
        for (int i=0; i < packages.size(); i++)
          if ( ((Packag) packages.get(i)).getID() == id)
          {
            // need to update info, because we may not have it
            ((Packag) packages.get(i)).reset(id, w, x, y, monkeyJuicer.getX(), monkeyJuicer.getY());
            crap = true;
            break;
          }

        if (!crap)
        {
          addPackage(id, w, x, y, monkeyJuicer.getX(), monkeyJuicer.getY());
        }
      }
    }
    catch (Exception e)
    {
      //e.printStackTrace();
      System.out.println("Mo's fault in updatePackages");
      throw e;
    }
  }

  public void updateRobots ()
  {
    try
    {
      StringTokenizer st = client.getTokenizer();
      int robot = -1; // ID, god damn it!
      Robot _robot = null;
      int X=-1;
      boolean pick = false;
      for (int i=0; i < robots.size(); i++)
        ((Robot) robots.get(i)).setAccessed(false);

      /* Since P with an empty list can occur
       * all tokens must be handled by the while loop
       * if the token is a number it must be package
       * we will set a flag in the "P" and "D" cases
       * -Aly, MA
       */
      while ( st.hasMoreElements() )
      {
        String token = st.nextToken();
        System.out.println("JUICERRRRRRRR: "+token);
        
        if (token.indexOf('#') > -1)
        {
          robot = Integer.parseInt(token.substring(1));
          _robot = null;
          for (int i=0; i < robots.size(); i++)
            if ( ((Robot) robots.get(i)).getID() == robot)
              _robot = ((Robot) robots.get(i));

          if (_robot != null)
            _robot.access = true;

        }
        else if (token.equals("P"))
        {
          pick = true;
          /*
          st.nextToken();

          int id = (int)st.nval;     // Package id
          Packag temp = null;
          if (_robot == null) continue;

          for (int i=0; i < packages.size(); i++)
            if ( ((Packag) packages.get(i)).getID() == id)
            {
              temp = ((Packag) packages.get(i));
              break;
            }
          if (temp == null)
            temp = addPackage(id, -1, -1, -1, _robot.getX(), _robot.getY());
         
          if (temp != null)
             _robot.pick(temp);
          */
        }
        else if (token.equals("D"))
        {
          pick = false;
          /*
          st.nextToken();

          int id = (int)st.nval;     // Package id
          Packag temp = null;
          if (_robot == null) continue;

          for (int i=0; i < packages.size(); i++)
            if ( ((Packag) packages.get(i)).getID() == id)
            {
              temp = ((Packag) packages.get(i));
              break;
            }
          if (temp == null)
            temp = addPackage(id, -1, -1, -1, _robot.getX(), _robot.getY());
         
          if (temp != null)
             _robot.drop(temp);
          */
        }
        else if (token.equals("X"))
        {
          X = Integer.parseInt(st.nextToken());
        }
        else if (token.equals("Y"))
        {
          addRobot(robot, -1, X, Integer.parseInt(st.nextToken()), -1); 
        }
        else if ("NEWS".indexOf( token.charAt(0) ) > -1 )
        {
          moveRobot( robot, token.charAt(0) );
        }
        else
        {
          int id = Integer.parseInt(token);
          if (pick)
          {
            Packag temp = null;
            if (_robot == null) continue;

            for (int i=0; i < packages.size(); i++)
              if ( ((Packag) packages.get(i)).getID() == id)
              {
                temp = ((Packag) packages.get(i));
                break;
              }
            if (temp == null)
              temp = addPackage(id, -1, -1, -1, _robot.getX(), _robot.getY());
           
            if (temp != null)
               _robot.pick(temp);
          }
          else
          {
            Packag temp = null;
            if (_robot == null) continue;

            for (int i=0; i < packages.size(); i++)
              if ( ((Packag) packages.get(i)).getID() == id)
              {
                temp = ((Packag) packages.get(i));
                break;
              }
            if (temp == null)
              temp = addPackage(id, -1, -1, -1, _robot.getX(), _robot.getY());
           
            if (temp != null)
            {
               _robot.drop(temp);
               // ZAID's JUICE UP OF OUR BEAUTIFUL CODE
               if (_robot == monkeyJuicer && monkeyJuicer.getX() == temp.finalX && monkeyJuicer.getY() == temp.finalY)
                {
                  monkeyJuicer.addScore(temp.weight);
                  FileWriter out = new FileWriter(monkeyJuicer.getID()+".ID");
                  String score = new String(monkeyJuicer.getScore()+"");
                  for (int i=0; i<14; i++)
                  {
                    score = score + " " + Coeffs[i];
                  }
                  out.write (score, 0, score.length());
                  out.write (10);
                  out.close ();

                  packages.remove(packages.indexOf(temp));
                }
               
            }
          }
        }
      }

      // remove dead robots
      for (int i=0; i < robots.size(); i++)
        if ( !((Robot) robots.get(i)).getAccessed() )
        {
          Robot r = ((Robot) robots.get(i));
          
          // remove packages from global list
          ArrayList p = r.getPackages();

          for (int j=0; j < p.size(); j++)
          {
             packages.remove(packages.indexOf(p.get(j)));
          }
          
          // Killing robot automatically kills packages
          robots.remove(i);
          if (r == monkeyJuicer) monkeyJuicer = null;
        }
    }
    catch (Exception e)
    {
      e.printStackTrace();
      System.out.println("Mo's fault in updateRobots");
    }
      
  }
 

  public int max (int a, int b) {return (a > b ? a : b);}

  public void justDoIt()
  {
    ArrayList pots = getMeSomePOT();

    int counter = 0;
    while (counter++ < 3)
    {

    Bfs BB = new Bfs(world, pots);
    String op = "";

    // HARD-CODED BID OF 1 !!!!!!!!!!!!!
    monkeyJuicer.money--;

    
    // HANDLE DROPS
    for (int i=0; i < monkeyJuicer.packages.size(); i++)
    {
      Packag p = ((Packag) monkeyJuicer.packages.get(i));
      if (p.finalX == monkeyJuicer.getX() && p.finalY == monkeyJuicer.getY())
      {
        op += " " + p.getID();
      }
    }
    if (!op.equals(""))
    {
      op = "1 Drop" + op + "\n";
      client.sendLine(op);
      return;
    }
    
    // HANDLE PACKAG`S
    // DO I WANT TO PICK UP PACKAGE IF I AM CARRYING SOME?
    int weightToCarry = monkeyJuicer.capacity - monkeyJuicer.totalWeight; 
    for (int i=0; i < packages.size(); i++)
    {
      Packag p = ((Packag) packages.get(i));
      if (p.IhaveIt != null && p.IhaveIt == monkeyJuicer) continue;

      if (p.getX() == monkeyJuicer.getX() && p.getY() == monkeyJuicer.getY())
      {
        if (weightToCarry >= p.weight)
        {
          // issue command to server to pick up package
          op += " " + p.getID();
          weightToCarry -= p.weight;
        }
               
      }
    }
    if (!op.equals(""))
    {
      op = "1 Pick" + op + "\n";
      client.sendLine(op);
      return;
    }


    int r = monkeyJuicer.getY();
    int c = monkeyJuicer.getX();

    int a, b, x, d;
    a = b = x = d = -1000000000;

    if (r > 1) a = BB.valueOf(r-1, c);
    if (r < world.rows) x = BB.valueOf(r+1, c);
    if (c > 1) d = BB.valueOf(r, c-1);
    if (c < world.cols) b = BB.valueOf(r, c+1);

    int m = max(a, max(b, max(x, d)));
    if (m == -1000000000)
    {
      client.sendLine("1 Pick\n");
      return;
    }
    else if (m == 0)
    {
      for (int i=0; i < pots.size(); i++)
        ((Functor) pots.get(i)).incRes(BB.factor);
    }
    else
    {
      if (m == a)
        client.sendLine("1 Move S\n");
      else if (m == b)
        client.sendLine("1 Move E\n");
      else if (m == x)
        client.sendLine("1 Move N\n");
      else
        client.sendLine("1 Move W\n");
      return;
    }
    }

    client.sendLine("1 Pick\n");
    
  }
  
  public static void main(String[] args)
  {
    Motha test = new Motha();
    test.client = new cSocket(args[0],args[1]);
    
    //if we have coeffs coming in
    if (args.length>2)
    {
      int coeff;
      for (coeff=2; coeff<args.length; coeff+=2)
      {
        Mult[(coeff/2)-1] = Integer.parseInt(args[coeff])/Integer.parseInt(args[coeff+1]);
      }
      for (coeff=2; coeff<args.length; coeff++)
      {
        Coeffs[coeff-2] = Integer.parseInt(args[coeff]);
      }
    }

    test.client.sendLine("Player\n");

    test.parseBoardSize(test.client.getLine());
    
   // test.parseBoardSize("7 5");     // Try to create a "world"
    /* See if it can handle the Sample world
    test.parseNextRow("..@....");
    test.parseNextRow(".......");
    test.parseNextRow("##.~~~~");
    test.parseNextRow("...~~~~");
    test.parseNextRow(".......");
    */
    for (int i=1; i <= test.world.rows; i++)
      test.parseNextRow(test.client.getLine());
    test.initOurRobot();
    System.out.println ("Our robot initialized");
    test.placeRobots();
    System.out.println ("Robots placed");

    test.debugBoard();
    // Initialize my own robot!
    //test.initOurRobot("3 25 1000");
    // Initialized all robot positions
    //test.placeRobots("#2 X 2 Y 1 #1 X 1 Y 2 #3 X 1 Y 1");
    test.debugRobots();

    // MOVE ME, SHAG ME, BAG ME
    try
    {
      while(test.monkeyJuicer != null) 
      {
        test.updatePackages();
        test.justDoIt();
        // check client for connection here!
        test.updateRobots();
      }
    }
    catch (Exception e)
    {
      System.out.println("Run terminated on "+e);
      e.printStackTrace(System.out); 
    }

  }
}
